#include <stdio.h>
#include <stdlib.h>
#include "xmd.h"

void getputlist(char *);
void initgame(void);
void getyabasa(char *);
void rewritename(void);
void countdown(XtPointer, XtIntervalId *);
void timerequest(XtPointer, XtIntervalId *);

int from;

xselect(XtPointer client_data,int *fd,XtInputId *id){
  int ret;
  int intpuyo;
  int ch=1;
  static int flag=0;
  int i,j,k,l,hoge;
  char buf[1024];
  char tmp[256];

  if((ret = read(*fd,buf,1024)) <= 0){
    if(flag==0){
      fprintf(stderr,"Maybe server down.\n");
     }else{
      fprintf(stderr,"Nickname collision.\nConnect to the server with another nickname.\n");
    }
    close(*fd);
    exit(1);
  }
  buf[ret]='\0';
  
  switch(st){
  case 0:
    if(strncmp(buf,"PUYO",4)==0){
      intpuyo=getpuyo(buf);
      putpuyo(intpuyo);
    }
    if(strncmp(buf,"LIST",4)==0){
      getputlist(buf);
      XawListChange(names,namelist,0,0,False);
    }
    if(strncmp(buf,"START",5)==0){

      XtAppAddTimeOut(app_con, 500,
		      countdown,
		      (XtPointer)NULL);

    }

    if(strncmp(buf,"NICK",4)==0){
      flag=1;
    }
    break;

    
  case 1:
    if(strncmp(buf,"WIN",3)==0){
      winner=buf[4]-'0';
      for(i=0;i<persons;i++){
	if(i!=winner)yabasa[i]=-1;
      }
      rewritename();
      XawListChange(names,namelist,0,0,False);

      XtVaSetValues(message,XtNlabel,"You win",NULL);
      XtPopup(popup_shell,XtGrabExclusive);
      st=4;
    }
    if(strncmp(buf,"ALL",3)==0){
      getyabasa(buf);
      rewritename();
      XawListChange(names,namelist,0,0,False);
    }
    if(strncmp(buf,"PUYO",4)==0){
      intpuyo=getpuyo(buf);
      ch=putpuyo(intpuyo);
      
      /*$BJV$jCM(Bch$B$,(B0$B$J$i$P;`K4$r0UL#$9$k(B*/
      if(ch==0){
	yabasa[mypd]=-1;
	rewritename();
	XawListChange(names,namelist,0,0,False);
	XtVaSetValues(message,XtNlabel,"Game Over",NULL);
	
	/* $B;`K4Js9p(B */
	sprintf(tmp,"MYSTATE:%d:*;",mypd);
	write(*fd,tmp,strlen(tmp));
	
	for (i=0;i<TATE;i++){
	  for (j=0;j<YOKO;j++){
	    map[j][i]=4;
	  }
	}
	draw(canvas);
	for(k=0;k<500000;k++);
	st=2;
      }
      draw(canvas);
    }      
    
    break;
    
  case 2:

    if(strncmp(buf,"ALL",3)==0){
      getyabasa(buf);
      rewritename();
      XawListChange(names,namelist,0,0,False);
    }

    
    if(strncmp(buf,"WIN",3)==0){
      winner=buf[4]-'0';
      for(i=0;i<persons;i++){
	if(i!=winner)yabasa[i]=-1;
      }
      rewritename();
      XawListChange(names,namelist,0,0,False);
      sprintf(buf,"%s Win\0",nicknames[winner]);
      XtVaSetValues(message,XtNlabel,buf,NULL);
      st=3;
    }
    
    break;
    
  }

  if(st==3){
    XtPopup(popup_shell,XtGrabExclusive);
    st=4;
  }
}

int getpuyo(char *buf){
  char charpuyo[9];
  char msg[20];
  int i;
  for(i=5;i<13;i++){
    charpuyo[i-5]=buf[i];
  }
  charpuyo[8]='\0';
  
  if(st==1){
    from=buf[14]-'0';
    if(from!=mypd){
      sprintf(msg,"from %s\0",nicknames[from]);
      XtVaSetValues(message,XtNlabel,msg,NULL);
    } 
  }
  
  i=atoi(charpuyo);
  return i;
  
}

int putpuyo(int intpuyo){
  int i,j,dev=1;
  for (i=0;i<YOKO;i++){
    if (map[i][TATE-1]!=-1) return 0;
  }
  for (i=TATE-2;i>=0;i--){
    for (j=0;j<YOKO;j++){
      map[j][i+1]=map[j][i];
    }
  }
/*  NULL; */
if(st==1){
  if(from!=mypd){  
    for(j=0;j<YOKO;j++){
      map[j][0]=5;
    }
  }
  
  draw(canvas);
  for(j=0;j<RAG*2;j++);
}
  for(j=0;j<YOKO;j++){
    map[j][0]=(intpuyo / dev % 10 )-1;
    dev=dev*10;
  }
  return 1 ;
}


void getputlist(char *tmp){
  int i=4,j,k=0;
  char nicktmp[100];
  
  while(tmp[i]!=';'){
    j=0;
    i++;
    while(tmp[i]!=';' && tmp[i] !=':'){
      nicktmp[j]=tmp[i];
      j++;
      i++;
    }
    nicktmp[j]='\0';
    
    if (j!=0){
      strcpy(nicknames[k],nicktmp);
      if(strcmp(mynick,nicktmp)==0){
	mypd=k; 
      }
	k++;
  }
}  
  for(i=0;i<k;i++){
    sprintf(nicktmp,"%9s %2d\0",nicknames[i],yabasa[i]);
    namelist[i+2][3]='\0';
      strcat(namelist[i+2],nicktmp);
  }
  for(i=k;i<10;i++){
    namelist[i+2][3]='\0';
  }
  persons=k;
}


void initgame(void){


  XtVaSetValues(message,XtNlabel,"Game Start!",NULL);
  XawListChange(names,namelist,0,0,False);
/*
  sleep(1);
*/
  draw(canvas);

  id_timerequest = XtAppAddTimeOut(app_con, interval,
				timerequest,
				(XtPointer)NULL);

}

void getyabasa(char *tmp){
  int i,j=9,k;
  char yabatmp[3];
  for (i=0;i<persons;i++){
    k=0;
    yabatmp[0]='\0';
    yabatmp[1]='\0';
    yabatmp[2]='\0';

    while(tmp[j]!=':' && tmp[j]!=';'){
      yabatmp[k]=tmp[j];
      j++;k++;
    }
    if (strncmp(yabatmp,"*",1)==0){
      yabasa[i]=-1;
      if(ta==i){
	ta=-1;
	XtVaSetValues(target,XtNlabel,"Random",NULL);
      }
    }else{
      yabasa[i]=atoi(yabatmp);
    }
    if(tmp[j]==';'){
      return;
    }else{
      j++;
    }
  }
}

void rewritename(void){
  int i;
  char tmp[100];
  for(i=0;i<persons;i++){
    if(yabasa[i]<0){
      sprintf(tmp,"%9s Dead\0",nicknames[i]);
    }else{
      sprintf(tmp,"%9s %2d\0",nicknames[i],yabasa[i]);
    }
    namelist[i+2][3]='\0';
    strcat(namelist[i+2],tmp);
  }
  
}

void countdown(XtPointer client_data, XtIntervalId *id){
  static int count = 5;
  char countdownchar[20];

  sprintf(countdownchar,"%d %d %d %d %d",count, count, count, count, count);
  XtVaSetValues(message,
		XtNlabel, countdownchar,
		NULL);


  if(count == 0){
    st = 1;
    count = 5;
    initgame(); 
  }else{
    count--;
    XtAppAddTimeOut(app_con, 1000,
		    countdown,
		    (XtPointer)NULL);
  }

}








